con
  _clkmode = pll8x + xtal1
  _clkfreq = 80_000_000

obj
  tv : "LL_TV_8x8_010.spin"
  tile_def : "LL_Tiles_Vector_001.spin"
  gp : "LL_GP_Combined_010.spin"

var
  long screen         'Pointer to bytes that define the tile map
  long tile_start     'Pointer to start of tile definitions
  long palette_start  'Pointer to start of palette definitions
  long mode           'Current operating mode: false = writting visible data, true = vertical sync
  
  word tiles[1200]    'Screen contents: low bytes: tiles, high bytes: palettes
  word pos

pub main | i                                                               
  palette_start := @sample_palette
  tile_start := tile_def.start
  screen := @tiles[0]
  pos := 620
  repeat i from 0 to 1199
    tiles[i] := 1
  tv.start(@screen, round( 3_579_545.0 * 4_294_967_295.0 / float(_clkfreq)))
  tiles[pos] := 0

  repeat          
    gp.update
    if gp.combined(gp#up | gp#down | gp#left | gp#right)
      tiles[pos] := 1
      if gp.combined(gp#up) and pos > 39
        pos -= 40
      if gp.combined(gp#down) and pos < 1160
        pos += 40
      if gp.combined(gp#left) and pos > 0
        pos -= 1
      if gp.combined(gp#right) and pos < 1199
        pos += 1
      tiles[pos] := 0
      
    waitcnt(2_000_000 + cnt)

      

dat
sample_palette          byte $52, $5c, $5d, $57
  