var{{
____________________________________________
Copy the following variables into your code:
  long screen         'Pointer to bytes that define the tile map
  long tile_start     'Pointer to start of tile definitions
  long palette_start  'Pointer to start of palette definitions
  long mode           'Current operating mode: false = writting visible data, true = vertical sync
  
  word tiles[1200]    'Screen contents: low bytes: tiles, high bytes: palettes
}}
pub start(parameters, compile_time_color_frequency)
{{The starting address of the parameters (screen, tile_start...) should be passed to start via "parameters."
To save memory, the color frequency is calculated at compile-time using the following expression:
round( 3_579_545.0 * 4_294_967_295.0 / float(_clkfreq))}}
  
  color_frequency := compile_time_color_frequency
        
  return cognew(@entry, parameters)
  
dat
                                org          
entry                           movi ctra, #%0_00001_111 
                                mov frqa, color_frequency
                                mov vcfg, vcfg_value      
                                mov dira, dira_value       

main_loop                       rdword tile_map_ptr, par
                                mov temp0, par
                                add temp0, #4
                                rdword tile_def, temp0
                                add temp0, #4
                                rdword palette_def, temp0
                                    
                                mov counter2, #30 'vertical tiles 
field_loop                        mov temp1, #0        
                                 
                                  mov counter1, #8 'lines per tile                 
tile_line_loop                      mov vscl, hsync_vscl
                                    waitvid sync_palette, hsync_pixels        
                                    
                                    mov temp0, tile_map_ptr                                    
                                    mov counter0, #40 'tiles per scanline
                                    mov vscl, hborder_vscl
                                    waitvid sync_palette, hborder_pixels
                                    
line_loop                             rdbyte temp2, temp0  
                                      shl temp2, #4
                                      add temp0, #1
                                      rdbyte temp3, temp0
                                      shl temp3, #2      
                                      add temp3, palette_def
                                      rdlong palette, temp3        
                                      add temp2, tile_def  
                                      add temp2, temp1            
                                      rdword pixels, temp2    
                                      add temp0, #1         
                                      mov vscl, active_vscl   
                                      waitvid palette, pixels     
                                    djnz counter0, #line_loop              
                                                                        
                                    add temp1, #2                                                                                                            
                                  djnz counter1, #tile_line_loop        
                                                               
                                  add tile_map_ptr, #80
                                djnz counter2, #field_loop

                                mov temp3, par
                                add temp3, #12
                                wrlong long_max, temp3                                             
                                call #vsync_high
                                call #vsync_low
                                call #vsync_high
                                wrlong long_min, temp3
                                jmp #main_loop
                                                              
color_frequency                 long 192_175_359 'color frequency for 80 Mhz (will be initialzed by start)

long_max                        long $ffff_ffff
long_min                        long 0

vcfg_value                      long %0_10_1_0_1_000_00000000000_011_0_00000111
dira_value                      long %00000111_00000000_00000000_00000000

sync_palette                    byte $00, $02, $8a, $00
hsync_pixels                    long %%11_2222_1_0000000_11
vsync_pixels_high_0             long %%1111111_0000000_11
vsync_pixels_high_1             long %%1111111111111111
vsync_pixels_low_0              long %%0000000000000000
vsync_pixels_low_1              long %%00_1111111_0000000
hsync_vscl                      long 39 << 12 + 624
vsync_vscl                      long 188 << 12 + 3008
hborder_pixels                  long %%1111111111111111
hborder_vscl                    long 8 << 12 + 120 
active_vscl                     long 9 << 12 + 72

vsync_high                      mov counter0, #8
:loop                           mov vscl, hsync_vscl
                                waitvid sync_palette, vsync_pixels_high_0
                                mov vscl, vsync_vscl
                                waitvid sync_palette, vsync_pixels_high_1
                                djnz counter0, #:loop  
vsync_high_ret                  ret

vsync_low                       mov counter0, #6  
:loop                           mov vscl, vsync_vscl
                                waitvid sync_palette, vsync_pixels_low_0
                                mov vscl, hsync_vscl
                                waitvid sync_palette, vsync_pixels_low_1
                                djnz counter0, #:loop
vsync_low_ret                   ret

palette                         res 1
pixels                          res 1

tile_map_ptr                    res 1
tile_def                        res 1
palette_def                     res 1        

temp0                           res 1
temp1                           res 1
temp2                           res 1
temp3                           res 1

counter0                        res 1
counter1                        res 1
counter2                        res 1
counter3                        res 1

                                fit